--- miniSAPserver-0.1.2/sapserver.cpp	2003-05-18 14:00:57.000000000 +0200
+++ miniSAPserver-0.1.2-pvh/sapserver.cpp	2003-05-25 11:41:28.000000000 +0200
@@ -56,6 +56,7 @@
     char machine[128];
     char site[128];
     char address[128];
+    char port[6];
     prog *Next;
     prog *Prev;
 };
@@ -151,7 +152,7 @@
     char tligne[1024];
     prog * pp=new prog;
     unsigned int something=0;
-
+    memset(pp,0,sizeof(prog));
     fichier=fopen(path,"r");
     if(!fichier)
     {
@@ -177,10 +178,18 @@
 	}
         if(strstr(ligne,"[program]")) 
         {
+	    	
             if(something) /* We were in a program with at least one field filled */
             {
+	    /* if the port was not set put it to default 1234*/
+	    	if ( ! strlen(pp->port) )
+		{
+		  strcpy(pp->port,"1234");
+		}
+		
                 progs->add(pp);
                 pp=new prog;
+		memset(pp,0,sizeof(prog));
                 something=0;
             }
         }
@@ -219,6 +228,13 @@
             something=1;
 	    strcpy(pp->address,tligne);
         }
+
+	if(strstr(ligne,"port="))
+	{
+	    strgeta(ligne,tligne,'=');
+	    something=1;
+	    strcpy(pp->port,tligne);
+	}
     }
 
     if(something) progs->add(pp);
@@ -318,10 +334,10 @@
             u=%s \n\
             t=3247691400 3250117800 \n\
             a=type:test   \n\
-            m=audio 1234 udp 14 \n\
+            m=audio %s udp 14 \n\
             c=IN IP4 %s/15  \n\
             xxxxxxxxxxxxxxxxxxxxx \n ",pp->user,pp->machine,pp->name, \
-                pp->site,pp->address); 
+                pp->site,pp->port,pp->address); 
 
             /* Send it through the socket */
             if (sendto(fd,message,strlen(message),0, \
